<!-- Only this code goes in last version -->

<p id="intro">
    U ovoj lekciji promatrat ćemo ponašanje drugačije vrste digitalnih sklopova. Pogledat ćemo njihove osnovne
    implementacije i probleme koji se javljaju.
</p>
<hr>
<h2></h2>
<p id="uvodSimulacije">
    U nastavku ćemo razmatrati dva digitalna sklopa. Oba sklopa sastoje se od dva ulaza (ulaz <b>A</b> i <b>B</b>
    respektivno) te jednog izlaza (izlaz <b>f</b>). <br><br>
    Ulazi su prikazani kao ispunjene pločice s lijeve strane simbola sklopa. Trenutna vrijednost koju ulaz dovodi na
    digitalni sklop prikazana je u samoj pločici; istu je moguće mijenjati klikom miša na pločicu (ako je prethodno bila
    jedinica, vrijednost će se promijeniti u nulu i obratno). <br>
</p>

<h3><b>Primjer 1</b></h3>

<p id="tutorial1">

    Kako bismo ispitali ponašanje <b>sklopa 1</b> (sklop <b>primjera 1</b>) postavljat ćemo ulaze <b>A</b> i <b>B</b> u
    jedinicu i promatrati izlaz sklopa. <br><br>

    Lijevom tipkom miša kliknite na pločicu uz ulaz <b>A</b>. Uočite da se prilikom otpuštanja tipke miša vrijednost
    vraća na početnu (u ovom primjeru to je <b>0</b>). <br><br>
    Promotrimo li promjenu izlaza, uočit ćemo da izlaz postaje <b>1</b> kada je <b>A</b> u jedinici.
    Nakon što ste ovo isprobali, ponovite isto s ulazom <b>B</b>. <br><br>
    Lijevom tipkom miša kliknite na pločicu uz ulaz <b>B</b>. Postavljanjem vrijednosti ulaza <b>B</b> u jedinicu, izlaz
    ponovo postaje <b>1</b>. Nakon što tipku miša otpustite izlaz ponovo mijenja svoju vrijednost odnosno postaje
    <b>0</b>. <br><br>
</p>

<div id="canvas1">
    <p align="center">
        <canvas id="b1Canvas" width="350px" height="300px"></canvas>
    </p>
</div>
<p>
    Možemo primijetiti da prilikom postavljanja ulaza <b>A</b> ili <b>B</b> na <b>1</b>, izlaz sklopa postavlja se na
    <b>1</b>.
    Pokušajmo sada konstruirati jednostavnu tablicu istinitosti <b>sklopa 1</b>.
    Imamo 2 ulaza i 1 izlaz, naša će tablica imati 4 retka (plus jedan redak za nazive) i 3 stupca.

    <br>
    Tablica je prikazana u nastavku.<br>

</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica istinitosti <b>sklopa 1</b>.</div>

<!--Comment this: class="mlTableCC mlTableVR2"-->
<div align="center">
    <table class="mlTableCC mlTableVR2">
        <thead>
        <tr>
            <th>A</th>
            <th>B</th>
            <th>f</th>
        </tr>
        </thead>

        <tbody>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>0</td>
        </tr>

        <tr>
            <td>0</td>
            <td>1</td>
            <td>1</td>
        </tr>

        <tr>
            <td>1</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>0</td>
        </tr>
        </tbody>
    </table>
</div>

<p>
    <b>Kako smo popunili tablicu?</b> <br><br>
    Uz ulaze A, B = (0, 0) na izlazu <b>f</b> sklopa vidimo 0.
    Kada ulaz <b>A</b> postavimo u jedinicu, izlaz postaje <b>1</b>. Isto se događa i prilikom postavljanja ulaza
    <b>B</b> u jedinicu.
    Stoga je izlaz <b>f</b> za kombinacije (0, 1) i (1, 0) jednak <b>1</b>. <br><br>
    Zadnju kombinaciju ne možete isprobati uobičajenim korištenjem ove simulacije. Međutim možemo prevariti sklop tako
    da prvo stisnemo ulaz <b>A</b> a zatim ne otpuštajući tipku miša izađemo s pokazivačem miša izvan simulacije te
    otpustimo tipku miša. Tako će ulaz <b>A</b> ostati u jedinici. Isto možemo napraviti i za ulaz <b>B</b>, time smo
    postavili i kombinaciju (1, 1). Ako prema gornjim uputama podesimo tu kombinaciju na sklopu 1 vidjet ćemo da je
    njegov izlaz jednak <b>0</b>.
</p>

<p>Iz tablica istinitosti vidimo da se radi o poznatoj Booleovoj funkciji Ex-ILI (isključivo-ILI, engl. <i>XOR</i>). Ova
    funkcija na izlazu daje <b>1</b> ako su ulazi različiti ((0, 1) i (1, 0)) a inače <b>0</b>.</p>



<div class="mlNote">
    <h3><b>Zaključak:</b></h3>
    <p>
        <b>Sklop 1</b> kombinacijski je sklop kojemu izlaz ovisi isključivo o trenutnim vrijednostima njegovih ulaza.
        Ovisno o funkciji koju sklop ostvaruje, za bilo koju kombinaciju na ulazu dovoljno je pogledati u tablicu
        istinitosti kako bi saznali vrijednost na izlazu.
    </p>
</div>
<hr>
<h3><b>Primjer 2</b></h3>

<p id="tutorial2">
    Kako bismo ispitali ponašanje <b>sklopa 2</b> (sklop <b>primjera 2</b>) postavljat ćemo ulaze <b>A</b> i <b>B</b> u
    jedinicu i promatrati izlaz sklopa. <br><br>

    Lijevom tipkom miša kliknite na pločicu uz ulaz <b>A</b>.<br>
    Promotrimo li promjenu izlaza uočit ćemo da izlaz postaje <b>1</b> kada je <b>A</b> u jedinici. Nakon što <b>A</b>
    vratimo na <b>0</b> (otpustite li tipku miša sklop će to učiniti sam) izlaz sklopa 2 ostat će u jedinici. Daljnje
    postavljanje ulaza <b>A</b> neće imati utjecaja na izlaz ovog sklopa, svakako isprobajte i taj slučaj. <br><br>

    Pretpostavljajući da je izlaz sklopa ostao u jedinici isprobat ćemo na jednak način i ulaz <b>B</b> sklopa 2.
    <br><br>

    Lijevom tipkom miša kliknite na pločicu ulaza <b>B</b>. Zadržavanjem vrijednosti ulaza <b>B</b> u jedinici izlaz
    sklopa 2 postavlja se na <b>0</b>. Slično kao i s ulazom <b>A</b>, daljnje mijenjanje (postavljanje i vraćanje u
    nulu) ulaza <b>B</b> neće imati utjecaja na izlaz sklopa. Izlaz će sada ostati <b>0</b> što god doveli na ulaz
    <b>B</b>. Isprobajte i tu situaciju. <br><br>
</p>

<div id="canvas2">
    <p align="center">
        <canvas id="b2Canvas" width="350px" height="300px"></canvas>
    </p>
</div>

<p>
    Pokušajmo sada konstruirati jednostavnu tablicu istinitosti <b>sklopa 2</b>.
    Imamo 2 ulaza i 1 izlaz, naša će tablica imati 4 retka (plus jedan redak za nazive) i 3 stupaca.

    <br>
    Tablica je prikazana u nastavku.<br>
</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica istinitosti <b>sklopa 2</b> (prvi pokušaj)
</div>

<!--Comment this: class="mlTableCC mlTableVR2"-->
<div align="center">
    <table class="mlTableCC mlTableVR2">
        <thead>
        <tr>
            <th>A</th>
            <th>B</th>
            <th>f</th>
        </tr>
        </thead>

        <tbody>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>?</td>
        </tr>

        <tr>
            <td>0</td>
            <td>1</td>
            <td>0</td>
        </tr>

        <tr>
            <td>1</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>?</td>
        </tr>
        </tbody>
    </table>
</div>

<p>
    <b>Kako smo popunili tablicu?</b> <br>
</p>
<p style="color:darkred">
    Prvi redak tablice prva je kombinacija odnosno prvi minterm tablice istinitosti.
</p>
<p>
Prvi redak tablice (kombinacija (0, 0)) u kojem su <b>A</b> i <b>B</b> nula na izlazu sklopa vidimo
<b>0</b>. Pa je za kombinaciju A, B = (0, 0) <b>f</b> jednak <b>0</b>.
Postavimo li ulaz <b>A</b> u jedinicu izlaz će postati <b>1</b> i takav ostati čak i nakon što ulaz <b>A</b> vratimo na
<b>0</b>.
Gledajući sada ponovo prvi redak tablice (kombinacija (0, 0)) trebali bi napisati da je izlaz <b>f</b> jednak
<b>1</b>. Iz ovoga je vidljivo da
kod ovog sklopa izlaz nije funkcija samo trenutnih ulaza: još nešto (skriveno) utječe na izlaz sklopa. Stoga ćemo u tablici 1 kao izlaz upisati ?.
<br><br>

    Drugi i treći redak možemo ispuniti normalno promatrajući što se događa s izlazom sklopa 2 prilikom odgovarajućih kombinacija (kombinacije A = 0, B = 1 i A = 1, B = 0).
<br>
Izlaz <b>f</b> za kombinacije (0, 1) odlazi u <b>0</b> a za kombinaciju (1, 0) odlazi
<b>1</b> - pa to upisujemo u tablicu. Isprobajte ovo još jednom na samom sklopu. <br><br>
Četvrti redak tablice (kombinaciju (1, 1)) za sada ćemo označiti znakom
<b>"?"</b> jer nemamo dovoljno informacija da bi zaključili što treba biti na izlazu ovog sklopa.
</p>

<p>
    Iz prethodne analize vidljivo je da se sklop 2 ponaša drugačije u odnosu na sklop <b>1</b>. Dok je izlaz sklopa 1
    uvijek bio izravno određen samo i isključivo vrijednostima
    koje su dovedene na njegove ulaze A i B (kažemo da je njegov izlaz funkcija od A i B), izlaz sklopa 2 mora ovisiti o
    još nečemu. Naime, vidjeli smo da je za vrijednosti (0, 0)
    dovedene na ulaze <b>A</b> i <b>B</b> izlaz nekada bio <b>0</b> a nekada <b>1</b>. Slijedi da je izlaz sklopa 2
    određen vrijednostima koje su dovedene na ulaze <b>A</b> i <b>B</b>
    te još nekom skrivenom varijablom.
</p>

<p>
    Pokušajmo sada identificirati što bi u našem konkretnom slučaju ta skrivena varijabla mogla biti. Napravite
    eksperiment.
    Odgovarajućom kombinacijom vrijednosti na ulazima <b>A</b> i <b>B</b> postavite izlaz sklopa 2 u <b>1</b>. Potom
    vratite
    na ulaze <b>A</b> i <b>B</b> vrijednosti (0, 0). Što se događa s izlazom? On ostaje kakav je bio: <b>1</b>.
    Postavite sada
    na ulaze <b>A</b> i <b>B</b> kombinaciju uz koju će izlaz sklopa otići u <b>0</b>. Potom postavite ulaze <b>A</b>i
    <b>B</b>
    na (0, 0). Što se događa s izlazom? On opet ostaje kakav je u tom trenutku i bio: <b>0</b>.
</p>

<p>
    U ovom konkretnom slučaju, skrivena varijabla koja nam pomaže da odredimo novo stanje izlaza upravo je njegovo
    trenutno
    stanje, odnosno vrijednost koja je zapisana na izlazu sklopa tik prije dovođenja nove kombinacije vrijednosti na
    ulaze <b>A</b> i <b>B</b>.
</p>

<p>
    Ponašanje sklopa 2 sada možemo korektno opisati tablicom koja s lijeve strane uz vrijednosti ulaza <b>A</b> i
    <b>B</b> navodi i vrijednost
    koju ima skrivena varijabla (što je u opisanom slučaju upravo vrijednost koja se nalazi na izlazu sklopa tik prije
    dovođenja te pobude).
    Tu skrivenu varijablu označit ćemo slovom <b>Y</b>. Evo tablice.
</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica istinitosti <b>sklopa 2</b> (drugi pokušaj)
</div>

<!--Comment this: class="mlTableCC mlTableVR2"-->
<div align="center">
    <table class="mlTableCC mlTableVR2">
        <thead>
        <tr>
            <th>Y</th>
            <th>A</th>
            <th>B</th>
            <th>f</th>
        </tr>
        </thead>

        <tbody>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>0</td>
            <td>0</td>
        </tr>

        <tr>
            <td>0</td>
            <td>0</td>
            <td>1</td>
            <td>0</td>
        </tr>

        <tr>
            <td>0</td>
            <td>1</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>0</td>
            <td>1</td>
            <td>1</td>
            <td>X</td>
        </tr>

        <tr>
            <td>1</td>
            <td>0</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>0</td>
            <td>1</td>
            <td>0</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>1</td>
            <td>X</td>
        </tr>
        </tbody>
    </table>
</div>


<p>
    <b>Kako smo popunili tablicu?</b> <br><br>
    Pogledajmo prvi redak. Skrivena varijabla ima vrijednost <b>0</b> a ulazi <b>A</b> i <b>B</b> postavljeni su na (0,
    0). U ovom retku zapravo se pitamo:
    što će biti novi izlaz sklopa ako je trenutni izlaz sklopa <b>0</b> a na ulaze dovedemo kombinaciju (0, 0)? Odgovor
    je: <b>0</b>: vidjeli smo da pobuda
    (0, 0) ne mijenja vrijednost izlaza. <br><br>

    Pogledajmo drugi redak. Pitamo se: što će biti novi izlaz sklopa ako je trenutni izlaz sklopa <b>0</b> a na ulaze
    dovedemo kombinaciju (0, 1)? Odgovor je:
    opet <b>0</b>. Naime, vrijednost <b>1</b> na ulazu <b>B</b> imala je efekt upisivanja <b>0</b> na izlaz sklopa. No
    kako je na izlazu već vrijednost <b>0</b>,
    ona će i ostati. Isprobajte to na prethodnoj simulaciji sklopa. <br><br>

    Pogledajmo treći redak. Pitamo se: što će biti novi izlaz sklopa ako je trenutni izlaz sklopa <b>0</b> a na ulaze
    dovedemo kombinaciju (1, 0)? Odgovor je:
    <b>1</b>. Vrijednost <b>1</b> na ulazu <b>A</b> imala je efekt upisivanja <b>1</b> na izlaz sklopa. Stoga će se tada
    izlaz promijeniti iz <b>0</b> (njegova
    trenutna vrijednost) u <b>1</b>. Isprobajte i to na prethodnoj simulaciji sklopa. <br><br>

    Četvrti redak tablice je problematičan: uz prethodno opisano djelovanje ulaza <b>A</b> i <b>B</b> (kad je na
    <b>A</b> vrijednost <b>1</b>, na izlaz se upisuje <b>1</b>,
    a kad je na <b>B</b> vrijednost <b>1</b>, na izlaz se upisuje <b>0</b>), situacija kod koje je <b>A</b> i <b>B</b>
    postavljeno na (1, 1) kao da traži od sklopa da
    istovremeno na izlaz postavi i u <b>0</b> i u <b>1</b> - što je nemoguće. Stoga ćemo ovu kombinaciju ulaza
    proglasiti nedozvoljenom, a kao izlaz sklopa
    upisati znak X.

    Vrijednosti izlaza u recima pet do osam određene su na jednak način..
</p>

<div class="mlNote">
    <p>Varijabla <b>Y</b> koju sklop 2 skriva od nas nazvat ćemo <b><i>trenutno stanje sklopa</i></b>. Funkcija izlaza
        sklopa 2 ovisi o trenutnoj pobudi (ulazima <b>A</b> i <b>B</b>) te <b><i>trenutnom stanju sklopa</i></b>. <br>
        <b>Sekvencijski sklopovi </b>su sklopovi kod kojih izlaz nije funkcija samo trenutne pobude, već je funkcija
        trenutne pobude i trenutnog stanja sklopa.
    </p>
</div>

<br>
<hr>
<p>
    Osim tablice istinitosti (koju ovdje zovemo tablica promjene stanja), za prikaz načina na koji sklop pod djelovanjem
    ulaza (kažemo još: "pobude") mijenja stanje možemo koristiti i <i>dijagram promjene stanja</i>. To je dijagram koji
    pokazuje sva moguća stanja sekvencijskog sklopa te njihovu promjenu pod utjecajem djelovanja pobude, kako je
    prikazano na sljedećoj simulaciji (dijagramu stanja sklopa 2).
    Dva kružića predstavljaju dva različita stanja sklopa. Lijevi predstavlja situaciju u kojoj je stanje sklopa
    <b>0</b> (pa na izlazu čitamo vrijednost <b>0</b>),
    dok desni predstavlja situaciju u kojoj je stanje sklopa <b>1</b> (pa na izlazu čitamo vrijednost <b>1</b>).
    Strelice prikazuju kako pobuda mijenja stanje sklopa.
</p>

<div>
    <p align="center">
        <canvas id="diagram" width="750px" height="300px"></canvas>
    </p>
</div>

<div class="mlImportant">
    <p>
        <b>Bistabil</b> (<b>engl.</b> <i>flip-flop</i>) je sekvencijski sklop koji ima dva stabilna stanja. Kao što je
        prikazano na gornjem dijagramu, to su stanja "<b>0</b>" i "<b>1</b>". Varijabla <b>Y</b> kod bistabila upravo
        predstavlja njegovo stanje. Sklop 2 primjer je jednog bistabila.
        Kod bistabila, pojmom <i>stanje bistabila</i> ujedno označavamo i binarnu vrijednost koja se nalazi na njegovu
        izlazu. Za bistabil kažemo da je
        digitalni sklop koji omogućava pamćenje jednog bita informacije. Djelovanjem na ulaze bistabila, korisnik tu
        zapamćenu vrijednost može mijenjati.
    </p>

</div>


<br>
<p id="sažetak">
    U ovoj demonstraciji vidjeli smo dva različita ponašanja digitalnih sklopova. Sklop 1 <b>kombinacijski</b> je sklop
    kojemu izlaz ovisi isključivo o ulazima.
    Sklop 2 <b>sekvencijski</b> je sklop kojemu izlaz ovisi o <b>trenutnom stanju</b> i trenutnoj pobudi.
</p>

<p>Sada krećemo u istraživanje raznih načina rada sklopa 2 (bistabila).</p>

<script>
    /*@#page-include#(library.js)*/
    /*@#page-include#(example1.js)*/
</script>
